package org.gersteinlab.regulation.util;

/**
 *	<pre>
 *	This class provides functions for computing some simple statistics.
 *	</pre>
 *
 *	@author		Kevin Yuk-Lap Yip
 *	@version	1.0 (September 9, 2008)
 *
 *	<pre>
 *	Change History:
 *	1.0	- Initial version
 *	</pre>
 */
public class SimpleStats
{
	/**
	 *	Compute the mean of a vector.
	 *	@param		v		The vector
	 *	@return				The mean
	 */
	public static double getMean(double[] v)
	{
		int count = v.length;
		double sum = 0;
		for (int i=0; i<count; i++)
			sum += v[i];
		return sum / count;
	}

	/**
	 *	Compute the standard deviation of a vector.
	 *	@param		v		The vector
	 *	@return				The standard deviation
	 */
	public static double getSD(double[] v)
	{
		int count = v.length;
		double sum = 0;
		double sumSq = 0;
		for (int i=0; i<count; i++)
		{
			sum += v[i];
			sumSq += v[i] * v[i];
		}
		return Math.pow(sumSq / count - (sum / count) * (sum / count), 0.5);
	}
}